diff --git a/pc-bios/bios.bin b/pc-bios/bios.bin
index 4f4383b06a95cd0f479c9d9e8e07234748a7279b..f88412c89a73f19d2d5876a6d8db3c7d966e2231 100644
GIT binary patch
diff --git a/vl.c b/vl.c
index 12fe1f7..ae6d0c6 100644
--- a/vl.c
+++ b/vl.c
@@ -4074,6 +4074,7 @@ int main(int argc, char **argv, char **envp)
         }
 
         boot_menu = qemu_opt_get_bool(opts, "menu", boot_menu);
+        boot_strict = qemu_opt_get_bool(opts, "strict", false);
     }
 
     if (!kernel_cmdline) {